// Generated by CoffeeScript 1.12.7
var Converter, Gavel2Html, HeadersResultConverter, JsonResultConverter, TextResultConverter, transformJsonData;

Converter = require('./converter');

JsonResultConverter = require('./json-result-converter');

TextResultConverter = require('./text-result-converter');

HeadersResultConverter = require('./headers-result-converter');

transformJsonData = function(real, expected) {
  var e, expectedTransformed, realTransformed;
  try {
    realTransformed = JSON.parse(real);
    expectedTransformed = JSON.parse(expected);
  } catch (error) {
    e = error;
    return false;
  }
  return {
    real: realTransformed,
    expected: expectedTransformed
  };
};

Gavel2Html = (function() {
  function Gavel2Html(arg) {
    var fieldName, fieldResult, usePointers;
    fieldName = arg.fieldName, fieldResult = arg.fieldResult, usePointers = arg.usePointers;
    this.fieldName = fieldName;
    this.dataReal = fieldResult.values.actual;
    this.dataExpected = fieldResult.values.expected;
    this.fieldResult = fieldResult;
    this.usePointers = usePointers;
    this.usedErrors = [];
  }

  Gavel2Html.prototype.getHtml = function(givenOptions) {
    var addedStartTag, changedStartTag, commentEndTag, commentStartTag, comments, converter, e, endTag, html, identString, jsonKeyEndTag, jsonKeyStartTag, missingStartTag, options, result, startTag, wrapWith;
    if (givenOptions == null) {
      givenOptions = {};
    }
    wrapWith = givenOptions.wrapWith, startTag = givenOptions.startTag, endTag = givenOptions.endTag, jsonKeyStartTag = givenOptions.jsonKeyStartTag, jsonKeyEndTag = givenOptions.jsonKeyEndTag, missingStartTag = givenOptions.missingStartTag, addedStartTag = givenOptions.addedStartTag, changedStartTag = givenOptions.changedStartTag, comments = givenOptions.comments, commentStartTag = givenOptions.commentStartTag, commentEndTag = givenOptions.commentEndTag, identString = givenOptions.identString;
    options = {
      missingStartTag: missingStartTag,
      addedStartTag: addedStartTag,
      changedStartTag: changedStartTag,
      comments: comments,
      commentStartTag: commentStartTag,
      commentEndTag: commentEndTag,
      wrapWith: wrapWith || '##data',
      startTag: startTag || '<li>',
      endTag: endTag || '</li>',
      jsonKeyStartTag: jsonKeyStartTag || '',
      jsonKeyEndTag: jsonKeyEndTag || '',
      identString: identString || '  '
    };
    converter = this.getConverter();
    try {
      result = converter.getHtml(options);
      this.usedErrors = converter.usedErrors;
      return result;
    } catch (error) {
      e = error;
      console.error('gavelhtml: Internal error.\n', e);
      html = missingStartTag + "Internal validator error\n\n" + endTag;
      try {
        if (typeof this.dataReal !== 'string') {
          this.dataReal = JSON.stringify(this.dataReal);
        }
      } catch (error) {
        e = error;
        false;
      }
      html += this.dataReal;
      if (wrapWith) {
        html = wrapWith.replace('##data', function() {
          return html;
        });
      }
      return html;
    }
  };

  Gavel2Html.prototype.getConverter = function() {
    var options, ref, transformedData;
    options = {
      fieldName: this.fieldName,
      dataReal: this.dataReal,
      dataExpected: this.dataExpected,
      fieldResult: this.fieldResult,
      usePointers: this.usePointers
    };
    if (((ref = this.fieldResult) != null ? ref.kind : void 0) === 'json') {
      if (this.fieldName === 'headers') {
        return new HeadersResultConverter(options);
      }
      transformedData = transformJsonData(options.dataReal, options.dataExpected);
      if (transformedData) {
        options.dataReal = transformedData.real;
        options.dataExpected = transformedData.expected;
        return new JsonResultConverter(options);
      }
    }
    return new TextResultConverter(options);
  };

  return Gavel2Html;

})();

module.exports.Gavel2Html = Gavel2Html;
