// Generated by CoffeeScript 1.12.7
var Converter, HeadersResultConverter, clone,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

clone = require('clone');

Converter = require('./converter');

HeadersResultConverter = (function(superClass) {
  extend(HeadersResultConverter, superClass);

  function HeadersResultConverter() {
    return HeadersResultConverter.__super__.constructor.apply(this, arguments);
  }

  HeadersResultConverter.prototype.getLinesFromResults = function() {
    return this._getLines();
  };

  HeadersResultConverter.prototype._getLines = function() {
    var dataRealWithExpected, expectedKey, expectedValue, fn, k, lineResultGetter, lines, lowercasedExpectedKeys, lowercasedRealKeys, ref, ref1, v;
    lineResultGetter = this.getStateAndMessageFromResults;
    this.dataReal = this.getFromString(this.dataReal);
    this.dataExpected = this.getFromString(this.dataExpected);
    lowercasedExpectedKeys = Object.keys(this.dataExpected).map(function(s) {
      return s.toLowerCase();
    });
    lowercasedRealKeys = Object.keys(this.dataReal).map(function(s) {
      return s.toLowerCase();
    });
    dataRealWithExpected = clone(this.dataReal, false);
    ref = this.dataExpected;
    for (expectedKey in ref) {
      expectedValue = ref[expectedKey];
      if (ref1 = expectedKey.toLowerCase(), indexOf.call(lowercasedRealKeys, ref1) < 0) {
        dataRealWithExpected[expectedKey] = expectedValue;
      }
    }
    lines = [];
    fn = (function(_this) {
      return function(k, v) {
        var ref2, result;
        if (ref2 = k.toLowerCase(), indexOf.call(lowercasedExpectedKeys, ref2) < 0) {
          return lines.push({
            pathArray: [k],
            value: _this.dataReal[k],
            'state': 1,
            'message': void 0
          });
        } else {
          result = lineResultGetter.call(_this, {
            pathArray: [k],
            lowerCasedKeys: true
          });
          result['value'] = v;
          return lines.push(result);
        }
      };
    })(this);
    for (k in dataRealWithExpected) {
      v = dataRealWithExpected[k];
      fn(k, v);
    }
    return lines;
  };

  HeadersResultConverter.prototype.getHtmlPrivate = function() {
    var canOmitSanitize, html, i, len, line, lineKey, lineVal, lines;
    lines = this._getLines();
    html = '';
    canOmitSanitize = this.jsonKeyEndTag && this.jsonKeyStartTag;
    for (i = 0, len = lines.length; i < len; i++) {
      line = lines[i];
      lineKey = line['pathArray'];
      lineVal = line['value'];
      if (canOmitSanitize) {
        lineKey = this.sanitize(lineKey);
        lineVal = this.sanitize(lineVal);
      }
      html += this.formatFragment({
        omitSanitize: canOmitSanitize,
        fragment: "" + (this.jsonKeyStartTag || '') + lineKey + (this.jsonKeyEndTag || '') + ": " + lineVal,
        message: line['message'],
        status: line['state']
      });
    }
    return html;
  };

  HeadersResultConverter.prototype.getFromString = function(header) {
    var headersOut, i, key, len, line, ref, separator, value;
    if (!header || typeof header !== 'string') {
      return header;
    }
    headersOut = {};
    ref = header.split('\n');
    for (i = 0, len = ref.length; i < len; i++) {
      line = ref[i];
      separator = line.indexOf(':');
      if (separator === -1) {
        continue;
      }
      key = line.slice(0, separator).trim();
      value = line.slice(separator + 1).trim();
      headersOut[key] = value;
    }
    return headersOut;
  };

  return HeadersResultConverter;

})(Converter);

module.exports = HeadersResultConverter;
