// Generated by CoffeeScript 1.12.7
var Converter, JsonResultConverter, jsonPointer, traverse, type,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

traverse = require('traverse');

jsonPointer = require('json-pointer');

type = require('is-type');

Converter = require('./converter');

JsonResultConverter = (function(superClass) {
  extend(JsonResultConverter, superClass);

  function JsonResultConverter() {
    return JsonResultConverter.__super__.constructor.apply(this, arguments);
  }

  JsonResultConverter.prototype.getHtmlPrivate = function() {
    var closingBrackets, defaultEnd, defaultStart, error, errors, errorsMap, errorsPaths, findErrorsByPointerPath, formatParts, getIdent, i, indentLevel, keyTagWrapEnd, keyTagWrapStart, len, out, prevLevel, prevNode, s, sanitizeData, typesOnLevels, usedErrors, walking, writeEnd, writeStart, writtenEnd, writtenStart;
    out = '';
    prevLevel = 0;
    prevNode = null;
    errorsPaths = [];
    errors = this.getErrorsFromResults();
    closingBrackets = [];
    typesOnLevels = {};
    this.usedErrors = [];
    errorsMap = this.mapErrorsPositionByPath(errors);
    getIdent = this.getIdentFunction(this.identString);
    formatParts = this.formatFragmentPartsFunction(this);
    sanitizeData = this.sanitize.bind(this);
    usedErrors = this.usedErrors;
    for (i = 0, len = errors.length; i < len; i++) {
      error = errors[i];
      errorsPaths.push(jsonPointer.compile(error.pathArray));
    }
    s = '';
    indentLevel = 1;
    out = {};
    writtenStart = false;
    writtenEnd = false;
    defaultStart = "" + this.startTag;
    defaultEnd = "" + this.endTag;
    keyTagWrapStart = "" + (this.jsonKeyStartTag || '');
    keyTagWrapEnd = "" + (this.jsonKeyEndTag || '');
    writeStart = function(pieces, indentation) {
      if (pieces == null) {
        pieces = [defaultStart];
      }
      if (indentation == null) {
        indentation = '';
      }
      if (!writtenStart) {
        s += pieces[0] + indentation;
        pieces[0] = defaultStart;
        writtenEnd = !(writtenStart = true);
      }
    };
    writeEnd = function(pieces, newline) {
      if (pieces == null) {
        pieces = [defaultStart, [defaultEnd]];
      }
      if (newline == null) {
        newline = false;
      }
      if (!writtenEnd) {
        s += "" + (pieces[1].join(' ')) + (newline ? '\n' : '');
        pieces[1] = [pieces[1][0]];
        writtenStart = !(writtenEnd = true);
      }
    };
    findErrorsByPointerPath = function(pointerPath) {
      var errNo, errorOnThisPath, ref;
      errorOnThisPath = null;
      if ((out[pointerPath] != null) || (pointerPath == null)) {
        return;
      }
      errNo = errorsMap[pointerPath];
      if (errNo || errNo === 0) {
        errorOnThisPath = errors[errNo];
        if (errorOnThisPath.state !== 1) {
          usedErrors.push(pointerPath);
        }
      }
      if ((errorOnThisPath != null) && (pointerPath != null)) {
        out[pointerPath] = formatParts({
          status: errorOnThisPath.state,
          message: (ref = errorOnThisPath.message) != null ? ref.replace('The undefined property', 'The property') : void 0
        });
      } else {
        out[pointerPath] = formatParts({
          status: 0
        });
      }
    };
    walking = function(node, preStringValue, postStringValue) {
      var compiledPath, ref;
      compiledPath = null;
      if (this.path) {
        compiledPath = jsonPointer.compile(this.path);
      }
      if (this.path == null) {
        compiledPath = compiledPath;
      } else if (!this.isRoot || (this.isRoot && ((ref = typeof node) === 'number' || ref === 'string'))) {
        findErrorsByPointerPath(compiledPath);
      }
      if (Array.isArray(node)) {
        this.before(function() {
          if (this.isRoot) {
            writeStart(out[compiledPath]);
          }
          s += '[';
          if (!this.isLeaf) {
            indentLevel = indentLevel + 1;
            writeEnd(out[compiledPath], true);
          }
        });
        this.pre(function(x, key) {
          var pointerHere;
          pointerHere = jsonPointer.compile([].concat(this.path).concat(key));
          findErrorsByPointerPath(pointerHere);
          writeStart(out[pointerHere], getIdent(indentLevel));
        });
        this.post(function(child) {
          var pointerHere;
          pointerHere = jsonPointer.compile([].concat(this.path).concat(child.path));
          findErrorsByPointerPath(pointerHere);
          if (!child.isLast) {
            s += ',';
          }
          writeEnd(out[pointerHere], true);
        });
        this.after(function() {
          if (!this.isLeaf) {
            indentLevel = (indentLevel - 1) || 1;
            writeStart(out[compiledPath], getIdent(indentLevel));
          }
          s += ']';
          if (this.isRoot) {
            writeEnd(out[compiledPath]);
          }
        });
      } else if (typeof node === 'object') {
        this.before(function() {
          if (this.isRoot) {
            writeStart(out[compiledPath]);
          }
          s += '{';
          if (!this.isLeaf) {
            indentLevel = indentLevel + 1;
            writeEnd(out[compiledPath], true);
          }
        });
        this.pre(function(x, key) {
          var pointerHere;
          pointerHere = jsonPointer.compile([].concat(this.path).concat(key));
          findErrorsByPointerPath(pointerHere);
          writeStart(out[pointerHere], getIdent(indentLevel));
          walking(key, keyTagWrapStart, keyTagWrapEnd);
          s += ': ';
        });
        this.post(function(child) {
          var pointerHere;
          pointerHere = jsonPointer.compile([].concat(this.path).concat(child.path));
          findErrorsByPointerPath(pointerHere);
          if (!child.isLast) {
            s += ',';
          }
          writeEnd(out[pointerHere], true);
        });
        this.after(function() {
          if (!this.isLeaf) {
            indentLevel = (indentLevel - 1) || 1;
            writeStart(out[compiledPath], getIdent(indentLevel));
          }
          s += '}';
          if (this.isRoot) {
            writeEnd(out[compiledPath]);
          }
        });
      } else if (typeof node === 'string') {
        if (this.isRoot) {
          writeStart(out[compiledPath]);
        }
        s += '&quot;';
        if (preStringValue) {
          s += preStringValue;
        }
        s += sanitizeData(node.toString().replace(/"/g, '\"').replace('$', '$$'));
        if (postStringValue) {
          s += postStringValue;
        }
        s += '&quot;';
        if (this.isRoot) {
          writeEnd(out[compiledPath]);
        }
      } else {
        if (this.isRoot) {
          writeStart(out[compiledPath]);
        }
        s += sanitizeData(node.toString());
        if (this.isRoot) {
          writeEnd(out[compiledPath]);
        }
      }
    };
    traverse(this.dataReal).forEach(walking);
    this.usedErrors = usedErrors;
    return s;
  };

  JsonResultConverter.prototype.formatFragmentPartsFunction = function(thisInstance) {
    return function(options) {
      return thisInstance.formatFragmentParts(options);
    };
  };

  JsonResultConverter.prototype.getIdentFunction = function(identString) {
    return function(level) {
      if (identString) {
        return (new Array(level)).join(identString);
      }
      return '';
    };
  };

  JsonResultConverter.prototype.getErrorsFromResults = function() {
    var dataExpectedPointers, error, errors, errorsPaths, i, len, pathArray, pointer, ref, ref1;
    if (this.fieldResult.errors.length === 0) {
      return [];
    }
    errorsPaths = {};
    errors = [];
    dataExpectedPointers = [];
    traverse(this.dataExpected).forEach(function(nodeValue) {
      dataExpectedPointers.push(jsonPointer.compile(this.path));
    });
    traverse(this.dataReal).forEach(function(nodeValue) {
      var ref;
      if (!(ref = jsonPointer.compile(this.path), indexOf.call(dataExpectedPointers, ref) >= 0)) {
        errors.push({
          pathArray: this.path,
          value: nodeValue,
          'state': 1,
          'message': void 0
        });
      }
    });
    ref = this.fieldResult.errors;
    for (i = 0, len = ref.length; i < len; i++) {
      error = ref[i];
      if (((ref1 = error.location) != null ? ref1.pointer : void 0) != null) {
        errorsPaths[error.location.pointer] = jsonPointer.parse(error.location.pointer);
      }
    }
    for (pointer in errorsPaths) {
      pathArray = errorsPaths[pointer];
      errors.push(this.getStateAndMessageFromResults({
        pathArray: pathArray,
        lowerCasedKeys: false
      }));
    }
    return errors;
  };

  JsonResultConverter.prototype.mapErrorsPositionByPath = function(errors) {
    var error, i, len, map, position;
    map = {};
    position = 0;
    for (i = 0, len = errors.length; i < len; i++) {
      error = errors[i];
      map[jsonPointer.compile(error['pathArray'])] = position;
      position++;
    }
    return map;
  };

  return JsonResultConverter;

})(Converter);

module.exports = JsonResultConverter;
