// Generated by CoffeeScript 1.12.7
var Converter, DiffMatchPatch, TextResultConverter,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

DiffMatchPatch = require('googlediff');

Converter = require('./converter');

TextResultConverter = (function(superClass) {
  extend(TextResultConverter, superClass);

  function TextResultConverter() {
    return TextResultConverter.__super__.constructor.apply(this, arguments);
  }

  TextResultConverter.prototype.getHtmlPrivate = function() {
    var dataError, diff, diffError, diffs, dmp, e, html, i, len;
    if (this.dataExpected === this.dataReal) {
      return this.sanitize(this.dataReal);
    }
    dmp = new DiffMatchPatch;
    dataError = false;
    diffError = false;
    try {
      if (typeof this.dataExpected !== 'string') {
        this.dataExpected = JSON.stringify(this.dataExpected);
      }
    } catch (error) {
      e = error;
      dataError = true;
    }
    try {
      if (typeof this.dataReal !== 'string') {
        this.dataReal = JSON.stringify(this.dataReal);
      }
    } catch (error) {
      e = error;
      dataError = true;
    }
    html = '';
    try {
      diffs = dmp.diff_main(this.dataExpected, this.dataReal, true);
    } catch (error) {
      e = error;
      diffError = true;
    }
    if (dataError) {
      html += this.formatFragment({
        fragment: "Malformed data error\n\n",
        status: -1
      });
    }
    if (!diffError) {
      for (i = 0, len = diffs.length; i < len; i++) {
        diff = diffs[i];
        html += this.formatFragment({
          fragment: diff[1],
          status: diff[0]
        });
      }
    } else {
      html += this.formatFragment({
        fragment: "Internal validator error\n\n",
        status: -1
      });
      html += this.formatFragment({
        fragment: this.dataReal,
        status: -1
      });
    }
    return html;
  };

  return TextResultConverter;

})(Converter);

module.exports = TextResultConverter;
